<?php
namespace Geral\Repositories;

class Sistema extends \Doctrine\ORM\EntityRepository
{
	public static function getProdutosComerConflitantes($listaSistemas)
	{
		$sql = "SELECT P.CDPROCOMERCI, P.NMPROCOMERCI, P.CDPROCOMERELAC, P.NMPROCOMERELAC
				  FROM (SELECT SUM(1) OVER (PARTITION BY SOMA, MULT 
				                                ORDER BY SOMA 
				                                 ROWS BETWEEN UNBOUNDED PRECEDING 
				                                  AND CURRENT ROW) NRCONTADOR,
				               SOMA, MULT, CDPROCOMERCI, NMPROCOMERCI, CDPROCOMERELAC, NMPROCOMERELAC 
				          FROM (SELECT PP.CDPROCOMERCI, PP.NMPROCOMERCI, -- COMBINAÇÃO DOS PRODUTOS COMERCIAIS DOS SISTEMAS ENTRE SI
				                       PA.CDPROCOMERCI CDPROCOMERELAC, PA.NMPROCOMERCI NMPROCOMERELAC,
				                       TO_NUMBER(PP.CDPROCOMERCI) + TO_NUMBER(PA.CDPROCOMERCI) SOMA,
				                       TO_NUMBER(PP.CDPROCOMERCI) * TO_NUMBER(PA.CDPROCOMERCI) MULT
				                  FROM (SELECT DISTINCT PC.CDPROCOMERCI, PC.NMPROCOMERCI
				                          FROM SISTEMA SI, PROCOMERCI PC
				                         WHERE (INSTR(:LISTASIST, SI.CDSISTEMA) > 0)
				                           AND PC.CDPROCOMERCI = SI.CDPROCOMERCI) PP,
				                       (SELECT DISTINCT PC.CDPROCOMERCI, PC.NMPROCOMERCI
				                          FROM SISTEMA SI, PROCOMERCI PC
				                         WHERE (INSTR(:LISTASIST, SI.CDSISTEMA) > 0)
				                           AND PC.CDPROCOMERCI = SI.CDPROCOMERCI) PA
				                 WHERE PP.CDPROCOMERCI <> PA.CDPROCOMERCI) 
				         ORDER BY SOMA, MULT) P, 
				       RELACPROCOMER RP1, 
				       RELACPROCOMER RP2
				 WHERE P.NRCONTADOR           = 1
				   AND RP1.CDPROCOMERCI (+)   = P.CDPROCOMERCI
				   AND RP1.CDPROCOMERELAC (+) = P.CDPROCOMERELAC
				   AND RP2.CDPROCOMERCI (+)   = P.CDPROCOMERELAC
				   AND RP2.CDPROCOMERELAC (+) = P.CDPROCOMERCI
				   AND RP1.CDPROCOMERCI IS NULL
				   AND RP2.CDPROCOMERCI IS NULL";

        $params = array("LISTASIST" => $listaSistemas);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}